# class KDockManager | The manager that knows all dockwidgets and handles the dock process (and member of the dockwidget class set). More...
Definition | `#include <kdockwidget.h>`
Inherits | QObject (qt) [public ]
List of all Methods
Annotated List
Files
Globals
Hierarchy
Index

#### Public Methods

- KDockManager ( QWidget* mainWindow, const char* name = 0L )
- virtual ~KDockManager ()
- void writeConfig ( KConfig* c = 0L, QString group = QString::null )
- void readConfig ( KConfig* c = 0L, QString group = QString::null )
- void writeConfig (QDomElement &base)
- void readConfig (QDomElement &base)
- void activate ()
- virtual bool eventFilter ( QObject *, QEvent * )
- KDockWidget* findWidgetParentDock ( QWidget* w)
- void makeWidgetDockVisible ( QWidget* w )
- QPopupMenu* dockHideShowMenu ()
- KDockWidget* getDockWidgetFromName ( const QString& dockName )

#### Signals

- void change ()
- void replaceDock ( KDockWidget* oldDock, KDockWidget* newDock )
- void setDockDefaultPos ( KDockWidget* )

## Detailed Description

The manager that knows all dockwidgets and handles the dock process (and member of the dockwidget class set). More or less a helper class for the KDockWidget class set but of interest for some functionality that can be called within a KDockMainWindow or a KDockWidget .

An important feature is the ability to read or save the current state of all things concerning to dockwidgets to KConfig .

The dockmanager is also often used when a certain dockwidget or a child of such dockwidget must be found.

KDockManager ( QWidget* mainWindow, const char* name = 0L ) | ### KDockManager

Constructs a dockmanager. Some initialization happen:

- It installs an event filter for the main window,
- a control list for dock objects
- a control list for menu items concerning to menus provided by the dockmanager
- Some state variables are set

Parameters:

mainWindow | the main window controlled by this
name | the internal QOject name

~KDockManager () | ### ~KDockManager

[virtual]

Destructs a dockmanager.

void writeConfig ( KConfig* c = 0L, QString group = QString::null ) | ### writeConfig

Saves the current state of the dockmanager and of all controlled widgets. State means here to save the geometry, visibility, parents, internal object names, orientation, separator positions, dockwidget-group information, tab widget states (if it is a tab group) and last but not least some necessary things for recovering the dockmainwindow state.

Parameters:

c | the KDE configuration saver
group | the name of the section in KConfig

void readConfig ( KConfig* c = 0L, QString group = QString::null ) | ### readConfig

Like writeConfig but reads the whole stuff in.

In order to restore a window configuration from a config file, it looks up widgets by name (QObject::name) in the childDock variable of KDockManager. This list in turn contains all KDockWidgets (according to the KDockWidget constructor). So in principle, in order to restore a window layout, one must first construct all widgets, put each of them in a KDockWidget and then call readConfig(). And for all that to work, each widget must have a unique name.

Parameters:

c | the KDE configuration saver
group | the name of the section in KConfig

void writeConfig (QDomElement &base) | ### writeConfig

Saves the current dock window layout into a DOM tree below the given element.

void readConfig (QDomElement &base) | ### readConfig

Reads the current dock window layout from a DOM tree below the given element.

void activate () | ### activate

Shows all encapsulated widgets of all controlled dockwidgets and shows all dockwidgets which are parent of a dockwidget tab group.

bool eventFilter ( QObject *, QEvent * ) | ### eventFilter

[virtual]

It's more or less a method that catches several events which are interesting for the dockmanager. Mainly mouse events during the drag process of a dockwidgets are of interest here.

Parameters:

_ | the object that sends the event
_ | the event

Returns: the return value of the method call of the base class method

Reimplemented from QObject.

KDockWidget* findWidgetParentDock ( QWidget* w) | ### findWidgetParentDock

This method finds out what a widgets' dockwidget is. That means the dockmanager has a look at all dockwidgets it knows and tells you when one of those dockwidgets covers the given widget.

Parameters:

w | any widget that is supposed to be encapsulated by one of the controlled dockwidgets

Returns: the dockwidget that encapsulates that widget, otherwise 0

void makeWidgetDockVisible ( QWidget* w ) | ### makeWidgetDockVisible

Works like makeDockVisible() but can be called for widgets that covered by a dockwidget.

Parameters:

w | the widget that is encapsulated by a dockwidget that turns to visible.

QPopupMenu* dockHideShowMenu () | ### dockHideShowMenu

Returns: the popupmenu for showing/hiding dockwidgets

KDockWidget* getDockWidgetFromName ( const QString& dockName ) | ### getDockWidgetFromName

Parameters:

dockName | an internal QObject name

Returns: the dockwidget that has got that internal QObject name

void change () | ### change

[signal]

Signals changes of the docking state of a dockwidget. Usually the dock-toolbar will be updated then.

void replaceDock ( KDockWidget* oldDock, KDockWidget* newDock ) | ### replaceDock

[signal]

Signals a dockwidget is replaced with another one.

void setDockDefaultPos ( KDockWidget* ) | ### setDockDefaultPos

[signal]

Signals a dockwidget without parent (toplevel) is shown.

- Version: $Id: kdockwidget.h,v 1.35 2001/01/29 07:14:45 falkbr Exp $
- Author: Max Judin (documentation: Falk Brettschneider).
- Generated: root@sparc.ports.openbsd.org on Wed May 2 09:37:45 2001, using kdoc 2.0a53.